<template>
  <aside class="gpa-resource-selector" :class="withFilters ? 'gpa-resource-selector--with-filters' : ''">
    <rui-search-form v-model="searchTerm" :disabled="!!showChildren" />

    <div v-if="withFilters" class="_filters _filters--no-top">
      <div class="_filters__section">
        <label>
          <input v-model="recommendedRotationGroups" type="checkbox">
          {{ $t('js.resources.selector.recommended_rotation_group') }}
          <gpa-crop-rotation-group-tags :groups-with-counts="patchCropRotationRecommendedGroups" size="small" />
        </label>
      </div>
    </div>
    <div v-if="withFilters" class="_filters _filters--no-top">
      <div class="_filters__section">
        <label>
          <input v-model="sameRotationGroups" type="checkbox">
          {{ $t('js.resources.selector.same_rotation_group') }}
          <gpa-crop-rotation-group-tags :groups="patchCropRotationCurrentGroups" size="small" />
        </label>
      </div>
    </div>

    <rui-list-item v-if="allowNull"
                   :caption="$t('js.resources.selector.no_resource')"
                   :sub-caption="$t('js.resources.selector.no_resource_text')"
                   :active="!selectedResourceId"
                   class="-mhd -clickable"
                   @choose="handleResourceSelection" />

    <rui-empty v-if="resources.length === 0" class="-md" inline>{{ $t('js.resources.selector.empty') }}</rui-empty>

    <recycle-scroller v-show="!showChildren"
                      v-slot="{ item }"
                      key-field="id"
                      :items="resources"
                      :item-size="48"
                      class="gpa-resource-selector__items _virtual-scroll-area">
      <gpa-resource-selector-resource :resource="item.resource"
                                      :children="item.children"
                                      :selected-id="selectedResourceId"
                                      :resource-interactions-groups="resourceInteractionGroups"
                                      class="-clickable"
                                      @choose="handleResourceSelection"
                                      @show-children="handleChildrenDisplay" />
    </recycle-scroller>

    <div v-if="showChildren" class="gpa-resource-selector__items">
      <div class="gpa-resource-selector__items__title">
        <rui-button icon="caret-left" text @click="showChildren=null" />
        <h3>{{ parentName }}</h3>
      </div>

      <recycle-scroller v-slot="{ item }"
                        key-field="id"
                        :items="showChildren"
                        :item-size="47"
                        class="_virtual-scroll-area">
        <gpa-resource-selector-resource :resource="item.resource"
                                        :children="item.children"
                                        :selected-id="selectedResourceId"
                                        :resource-interactions-groups="resourceInteractionGroups"
                                        class="-clickable"
                                        @choose="handleResourceSelection"
                                        @show-children="handleChildrenDisplay" />
      </recycle-scroller>
    </div>
  </aside>
</template>

<script>
import { determineNextGroupsFor, rotationGroupsFor } from '../../../../../../helpers/RotationGroups.js'
import Patch from '../../../../../classes/models/Patch'

import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import GpaCropRotationGroupTags from '../../../../../common/CropRotation/GroupTags.vue'
import GpaResourceSelectorResource from './Resource.vue'

/**
 * @typedef {import('../../../../../classes/models/Resource')} Resource
 */

export default {
  name: 'GpaResourceSelector',
  emits: [
    'done',
    'choose',
  ],
  components: { RuiEmpty, RuiButton, RuiSearchForm, RuiListItem, GpaCropRotationGroupTags, GpaResourceSelectorResource },
  props: {
    selectedResourceId: { required: false, type: Number, default: null },
    patch: { required: false, type: Patch, default: null },
    allowNull: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      showDescriptionOf: null,
      searchTerm: '',
      sameRotationGroups: false,
      recommendedRotationGroups: false,
      showChildren: null,
      parentName: null,
    }
  },
  computed: {
    patchCropRotationRecommendedGroups () {
      if (!this.patch) return []

      return determineNextGroupsFor(this.patch.lastYearElements)
    },
    patchCropRotationCurrentGroups () {
      if (!this.patch) return []

      return rotationGroupsFor(this.patch.activeElements)
    },
    resources () {
      const recommended = Object.keys(this.patchCropRotationRecommendedGroups)

      return this.$store.getters.resourcesGroupedByParent(this.searchTerm)
        .filter((r) => {
          if (this.sameRotationGroups && !this.patchCropRotationCurrentGroups.includes(r.resource.cropRotationGroup)) return false
          if (this.recommendedRotationGroups && !recommended.includes(r.resource.cropRotationGroup)) return false

          return true
        })
    },
    resourceInteractionGroups () {
      if (!this.patch) return []

      /** @type {Resource[]} resources */
      const resources = this.patch.activeElements.map(e => e.resource)
      const groups = []

      // Find unique groups
      resources.forEach((resource) => {
        const group = resource.resourceInteractionsGroup
        if (!group) return

        if (groups.findIndex(g => g.id === group.id) === -1) groups.push(group)
      })

      return groups
    },
    withFilters () { return this.patchCropRotationCurrentGroups.length > 0 || this.patchCropRotationRecommendedGroups.length > 0 },
  },
  methods: {
    handleResourceSelection (resource) {
      if (this.patch) {
        const payload = { resource_id: resource.id, patch_id: this.patch.id }
        this.$store.dispatch('createElement', { payload })
          .then(() => this.$emit('done'))
      } else {
        this.$emit('choose', resource)
      }
    },
    handleChildrenDisplay ({ name, children }) {
      this.showChildren = children.map(c => ({ id: c.id, resource: c, children: [] }))
      this.parentName = name
    },
  },
}
</script>

<style lang="scss" src="./Selector.scss" />
